import string
import secrets

from mongo.get_conn import db_conn

class realestate_query:
    """
    This class will allow us to
    interact with our data to interact
    just create a realestate_data var
    """
    def __init__(self):
        #db_conn has all the the things
        #already created from here 
        #we can get self.db.real_db etc 
        self.db = db_conn()

    def record_exists(self, address):
        """
            This function will accept an address
            if it find that address in the database it will return True
            and set set the existing_record variable of the class to the 
            queried record
        """
        query = { "address" : f"{address}" }
        record = self.db.real_db.find_one(query)
        if record:
            self.existing_record = record
            return True
        else:
            return False

    def get_top(self, num_limit):
        """
            This function will return the
            top n records based on like_out_of_five
            It will take the number of records you want to 
            return as a parameter
        """
        records = self.db.real_db.find({}, {"address": 1, "_id": 0, "realestate_link": 1, "user_price": 1}).sort("like_out_of_five", -1).limit(num_limit)
        return records

    def user_check(self, username, password):
        """
            function to check username and password
            back in db
        """
        #TODO: this ueses my own quick hack it likley needs to be rewrittent to follow best practice

        query = { "username" : f"{username}", "password" : f"{password}" }
        record = self.db.users.find_one(query)
        if record:
            return True
        else:
            return False
